
/*
  interface QueueOptions {
    prefix?: string = 'bull',
    redis : RedisOpts, // ioredis defaults
    createClient: (redisOpts, type: enum('client', 'subscriber')) => redisClient
  }
*/

var QueueNew = function Queue(name, opts){
  if(!(this instanceof Queue)){
    return new Queue(name, opts);
  }

  if(opts && !_.isObject(opts)){
    throw Error('Options must be a valid object');
  }

  var opts = opts || {};
  var redisOpts = opts.redis || {};

  function createClient(type) {
    var client;
    if(_.isFunction(opts.createClient)){
      client = opts.createClient(type);
    }else{
      client = new redis(redisOpts);
    }
    return client;
  }

  this.name = name;
  this.keyPrefix = redisOpts.keyPrefix || opts.prefix || 'bull';
  this.token = uuid();

  //
  // We cannot use ioredis keyPrefix feature until we
  // stop creating keys dynamically in lua scripts.
  //
  delete redisOpts.keyPrefix;
}
